

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_DNSSOCKET_H
#define WWWI_MIND_DNSSOCKET_H


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"
#include "dnspacket.h"
#include "wwwi/mutex.h"
#include "wwwi/udpsocket.h"


using WWWI::Mutex;
using WWWI::UDPSocket;


/*************************
*                        *
*  FORWARD DECLARATIONS  *
*                        *
*************************/


/********************
*                   *
*  CLASS DNSSOCKET  *
*                   *
********************/


class DNSSocket : public UDPSocket {
public:
                        DNSSocket(IPAddress i_ipAddress = INADDR_ANY, unsigned short i_usPort = 0);
  virtual DNSPacketPtr  RecvPacket(void);
  virtual DNSPacketPtr  RecvPacketTimed(unsigned i_uTimeoutMS);
  virtual void          SendPacket(DNSPacketConstPtr i_dppOut);
  virtual              ~DNSSocket(void);

protected:
  Mutex m_mx;

};
DECL_POINTER_TYPES(DNSSocket)


/************
*           *
*  THE END  *
*           *
************/


#endif


