

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_DNSUTIL_H
#define WWWI_MIND_DNSUTIL_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"


using std::ostream;
using WWWI::SockAddrIn;


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


inline unsigned char         FromBits(bool i_b3, bool i_b2, bool i_b1, bool i_b0);
inline unsigned char         FromBits(bool i_b7, bool i_b6, bool i_b5, bool i_b4, bool i_b3, bool i_b2, bool i_b1, bool i_b0);
const char                  *GetClassName(RRClass i_cl);
const char                  *GetOpcodeName(Opcode i_op);
const char                  *GetRCodeName(RCode i_rc);
const char                  *GetTypeName(RRType i_ty);
inline bool                  IsRDataIP(RRType i_ty, RRClass i_cl);
inline bool                  IsRDataLabelList(RRType i_ty, RRClass i_cl);
inline bool                  MatchClass(RRClass i_cl1, RRClass i_cl2);
inline bool                  MatchType(RRType i_ty1, RRType i_ty2);
template <class T> void      SoftDelete(T* &io_tpr);
template <class T> void      SoftDeleteArray(T* &io_tpr);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "dnsutil.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


