

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_DTHREADPOOL_H
#define WWWI_MIND_DTHREADPOOL_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <pair.h>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "wwwi/rwlock.h"
#include "wwwi/semaphore.h"


using WWWI::RWLock;
using WWWI::Semaphore;


/**********************
*                     *
*  CLASS DTHREADPOOL  *
*                     *
**********************/


template <class Worker, class Initializer> class DynamicThreadPool {
public:
        DynamicThreadPool(unsigned i_uMinIdle, unsigned i_uMaxIdle, Initializer i_in);
  void  NewThread(void);
  void  PleaseShutdown(void);
  int   Thread(void);
       ~DynamicThreadPool(void);

protected:
  volatile bool  m_bShuttingDown;
  unsigned       m_uMinIdle;
  unsigned       m_uMaxIdle; 
  Mutex          m_mxNew;
  RWLock         m_rwThreads;
  Semaphore      m_seWaiting;
  Initializer    m_in;
  unsigned       m_uThreads;
};


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "dthreadpool.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


