

/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <cassert>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "am.h"
#include "dnsutil.h"
#include "label.h"


/***********************
*                      *
*  LABEL CONSTRUCTORS  *
*                      *
***********************/


Label::Label(unsigned short i_usLength, const char *ci_str) {
  AMCTOR(Label);
  m_str = NULL;
  this->Set(i_usLength,ci_str);
}


Label::Label(const Label &ci_lbr) {
  AMCTOR(Label);
  m_str = NULL;
  this->Set(ci_lbr.m_usLength,ci_lbr.m_str);
}


/*********************
*                    *
*  LABEL DESTRUCTOR  *
*                    *
*********************/


Label::~Label() {
  AMDTOR(Label);
  SoftDeleteArray(m_str);
}


