

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_LABEL_H
#define WWWI_MIND_LABEL_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"


/****************
*               *
*  CLASS LABEL  *
*               *
****************/


class Label {
public:
                         Label(unsigned short i_usLength, const char *ci_str);
                         Label(const Label &ci_lbr);
  inline bool            operator<(const Label &ci_lbr) const;
  inline Label          &operator=(const Label &ci_lbr);
  inline bool            operator==(const Label &ci_lbr) const;
  inline bool            operator!=(const Label &ci_lbr) const;
  inline unsigned short  GetLength(void) const;
  inline const char     *GetString(void) const;
                        ~Label(void);

protected:
  inline void            Set(unsigned short i_usLength, const char *ci_str);
  
public:
  unsigned short  m_usLength;
  char           *m_str;

};
typedef Label* LabelPtr;
typedef const Label *LabelConstPtr;


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


//ostream& operator<<(ostream& io_smr, const Label &i_lbr);
template <class SM> SM& operator<<(SM& io_smr, const Label &i_lbr);
template <class SM> SM& operator<<(SM& io_smr, const Label *i_lbp);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "label.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


