

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_LABELLIST_H
#define WWWI_MIND_LABELLIST_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <vector>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"
#include "label.h"


using std::vector;


/********************
*                   *
*  CLASS LABELLIST  *
*                   *
********************/


/*
 * This is used to represent the disassembled components of a name 
 * composed of various labels.  
 */

typedef vector<Label> LabelListParent;

class LabelList : public LabelListParent {
public:
                         LabelList(void);
  explicit               LabelList(const char *i_strName);
  explicit               LabelList(const unsigned char *ci_ucpLabels);
                         LabelList(const LabelList &ci_llr);
  unsigned short         GetRDLength(void) const;
  unsigned short         ToRaw(unsigned char *o_strOut) const;
  char                  *ToString(void) const;
  void                   ToString(char *o_strOut, size_t i_szOut) const;
                        ~LabelList(void);

};
DECL_POINTER_TYPES(LabelList)


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


ostream& operator<<(ostream& io_smr, const LabelList &i_llr);
ostream& operator<<(ostream& io_smr, LabelListConstPtr i_llp);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "labellist.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


