

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_QUESTION_H
#define WWWI_MIND_QUESTION_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"
#include "labellist.h"


/*******************
*                  *
*  CLASS QUESTION  *
*                  *
*******************/


class Question {
public:
                            Question(const char *i_strName, RRType i_ty, RRClass i_cl);
                            Question(LabelListPtr &i_llprName, RRType i_ty, RRClass i_cl);
                            Question(const Question &ci_qnr, LabelListConstPtr ci_llpCName);
                            Question(const Question &ci_qnr);
  inline LabelListConstPtr  GetName(void) const;
  inline RRClass            GetClass(void) const;
  inline RRType             GetType(void) const;
                           ~Question(void);

protected:
  LabelListPtr m_llpName;
  RRType m_ty;
  RRClass m_cl;
};
DECL_POINTER_TYPES(Question)


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


ostream& operator<<(ostream& io_smr, QuestionConstPtr ci_qnp);
ostream& operator<<(ostream& io_smr, const Question &ci_qnr);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "question.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


