

/*********************
*                    * 
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "rdata.h"
#include "rdata_a.h"
#include "rdata_mx.h"
#include "rdata_name.h"
#include "rdata_raw.h"
#include "rdata_soa.h"


/***************
*              *
*  METHOD NEW  *
*              *
***************/

/*
 *  NOTE: You must update this function if you create a new type of RData class.
 *  These are ordered in accordance with my WAG about frequency of occurrance.
 */

RDataPtr RData::New(RRType i_ty, RRClass i_cl) {
  if (RDataA::IsMatch(i_ty,i_cl)==true) return new RDataA;
  if (RDataName::IsMatch(i_ty,i_cl)==true) return new RDataName;
  if (RDataMX::IsMatch(i_ty,i_cl)==true) return new RDataMX;
  if (RDataSOA::IsMatch(i_ty,i_cl)==true) return new RDataSOA;
  return new RDataRaw;
}


/*********************
*                    *
*  RDATA DESTRUCTOR  *
*                    *
*********************/


RData::~RData() {}


