

/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "format.h"
#include "rdata_a.h"


using WWWI::IPDump;


/*****************
*                *
*  METHOD CLONE  *
*                *
*****************/


RDataPtr RDataA::Clone() const {
  RDataA *rdpOut = new RDataA;
  rdpOut->m_ip = m_ip; 
  return (RDataPtr)rdpOut;
}


/*******************
*                  *
*  METHOD COMPARE  *
*                  *
*******************/


bool RDataA::Compare(const RData &ci_rdr) const {
  return (ci_rdr.As<RDataA>()->GetRDAddress()==m_ip);
}

 
/****************
*               *
*  METHOD DUMP  *
*               *
****************/


void RDataA::Dump(ostream &io_smr) const {
  IPDump(io_smr,m_ip);
}


/************************
*                       *
*  METHOD GETRDADDRESS  *
*                       *
************************/


IPAddress RDataA::GetRDAddress() const { return m_ip; }


/*******************
*                  *
*  METHOD ISMATCH  *
*                  *
*******************/


bool RDataA::IsMatch(RRType i_ty, RRClass i_cl) {
  if (i_cl!=CL_IN) return false;
  if (i_ty==TY_A) return true;
  return false;
}           


/*********************
*                    *
*  METHOD READRDATA  *
*                    *
*********************/


void RDataA::ReadRData(BufferConstPtr ci_dpp) {
  unsigned short us;

  ci_dpp->ReadNBO(us);
  if (us!=sizeof(IPAddress)) 
    throw BadParseEx(FOUT("length of A was not ",sizeof(IPAddress)));
  ci_dpp->Read(m_ip);
}


/********************
*                   *
*  METHOD SETRDATA  *
*                   *
********************/


void RDataA::SetRData(const char *ci_strRData) {
  m_ip = inet_addr(ci_strRData);
  if (m_ip==(IPAddress)-1) 
    throw BadParseEx(FOUT("RDataA::SetRData: not an IP address: ",ci_strRData));
}


/**********************
*                     *
*  METHOD WRITERDATA  *
*                     *
**********************/


void RDataA::WriteRData(BufferPtr io_dpp) const {
  unsigned short us;

  us = sizeof(IPAddress);
  io_dpp->WriteNBO(us);
  io_dpp->Write(m_ip);
}


/**********************
*                     *
*  RDATAA DESTRUCTOR  *
*                     *
**********************/


RDataA::~RDataA() { m_ip = 0; }


