

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_RDATA_RAW_H
#define WWWI_MIND_RDATA_RAW_H


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "labellist.h"
#include "rdata.h"


/*******************
*                  *
*  CLASS RDATARAW  *
*                  *
*******************/

/*
 *  The RDataRaw class is used to represent unknown RRs.
 */

class RDataRaw : public RData {
public:
                            RDataRaw(void);
  virtual RDataPtr          Clone(void) const;
  virtual bool              Compare(const RData &ci_rdp) const;
  virtual void              Dump(ostream &io_smr) const;
  static bool               IsMatch(RRType i_ty, RRClass i_cl);
  virtual void              ReadRData(BufferConstPtr ci_dpp);
  virtual void              SetRData(const char *ci_strRData);
  virtual void              WriteRData(BufferPtr io_dpp) const;
  virtual                  ~RDataRaw(void);

protected:
  size_t m_szBuffer;
  unsigned char *m_ucpBuffer;
};


/************
*           *
*  THE END  *
*           *
************/


#endif


