

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_RDATA_SOA_H
#define WWWI_MIND_RDATA_SOA_H


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "labellist.h"
#include "rdata.h"


/*******************
*                  *
*  CLASS RDATASOA  *
*                  *
*******************/


class RDataSOA : public RData {
public:
                            RDataSOA(void);
  virtual RDataPtr          Clone(void) const;
  virtual bool              Compare(const RData &ci_rdp) const;
  virtual void              Dump(ostream &io_smr) const;
  LabelListConstPtr         GetRDSOA(void) const;
  static bool               IsMatch(RRType i_ty, RRClass i_cl);
  virtual void              ReadRData(BufferConstPtr ci_dpp);
  virtual void              SetRData(const char *ci_strRData);
  virtual void              WriteRData(BufferPtr io_dpp) const;
                           ~RDataSOA(void);

protected:
  LabelListPtr m_llpMName;
  LabelListPtr m_llpRName;
  unsigned m_uSerial;
  unsigned m_uRefresh;
  unsigned m_uRetry;
  unsigned m_uExpire;
  unsigned m_uMinimum;
};


/************
*           *
*  THE END  *
*           *
************/


#endif


