

/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <cassert>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "am.h"
#include "dnsutil.h"
#include "request.h"


/************************
*                       *
*  REQUEST CONSTRUCTOR  *
*                       *
************************/


Request::Request(bool i_bRD, Opcode i_op, QuestionPtr &i_qnpr) {
  AMCTOR(Request);
  m_bRD = i_bRD;
  m_op = OPCODE_QUERY;
  m_qnp = i_qnpr;
  i_qnpr = NULL;
}


/***********************
*                      *
*  REQUEST DESTRUCTOR  *
*                      *
***********************/


Request::~Request() {
  AMDTOR(Request);
  SoftDelete(m_qnp);
}


/*************************
*                        *
*  FUNCTIONS OPERATOR<<  *
*                        *
*************************/


ostream& operator<<(ostream& io_smr, RequestConstPtr i_rqpIn) {
  io_smr << *i_rqpIn;
  return io_smr;
}


ostream& operator<<(ostream& io_smr, const Request &i_rqrIn) {
  if (&i_rqrIn==NULL) {
    io_smr << "[NULL REQUEST]" << endl;
    return io_smr;
  }
  if (i_rqrIn.GetRD()) io_smr << "RD ";
  io_smr << GetOpcodeName(i_rqrIn.GetOpcode()) << " ";
  io_smr << i_rqrIn.GetQuestion();
  return io_smr;
}


