

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_REQUEST_H
#define WWWI_MIND_REQUEST_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "question.h"


/**********************
*                     *
*  TYPE DECLARATIONS  *
*                     *
**********************/


/******************
*                 *
*  CLASS REQUEST  *
*                 *
******************/


class Request {
public:
                          Request(bool i_bRD, Opcode i_op, QuestionPtr &i_qnpr);
  inline Opcode           GetOpcode(void) const;
  inline QuestionConstPtr GetQuestion(void) const;
  inline unsigned short   GetQuestionCount(void) const;
  inline bool             GetRD(void) const;
                         ~Request(void);

protected:
  bool m_bRD;
  Opcode m_op;
  QuestionPtr m_qnp;

};
DECL_POINTER_TYPES(Request)


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


ostream& operator<<(ostream& io_smr, RequestConstPtr i_rqpIn);
ostream& operator<<(ostream& io_smr, const Request &i_rqrIn);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "request.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


