

/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "requesttable.h"
#include "wwwi/mutexholder.h"
#include "wwwi/string.h"


/*********************
*                    *
*  METHOD ISINTABLE  *
*                    *
*********************/


bool RequestTable::IsInTable(RequestPtr i_requestPtr) {
  MutexHolder mh(&m_mutex);
  RequestMap::iterator itStart;
  RequestMap::iterator itEnd;
  RequestMap::iterator it;

  make_pair(itStart,itEnd) = m_requestMap.equal_range(i_requestPtr->GetID());
  if (itStart==m_requestMap.end()) return false;
  for(it=itStart;it!=itEnd;it++) {
    cout << "Checking " << i_requestPtr->GetID() << " vs. " << (*it).first << endl;
    if (memcmp(i_requestPtr->m_saiRemotePtr,(*it).second->m_saiRemotePtr,sizeof(SockAddrIn))==0) return true;
  }
  
  return false;
}


/***************
*              *
*  METHOD ADD  *
*              *
***************/


void RequestTable::Add(RequestPtr i_requestPtr) {
  cout << "Adding " << i_requestPtr->GetID() << endl;
  m_requestMap.insert(make_pair(i_requestPtr->GetID(),i_requestPtr));
}


