

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_REQUESTTABLE_H
#define WWWI_MIND_REQUESTTABLE_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <hash_map>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"
#include "request.h"
#include "wwwi/mutex.h"


/**********************
*                     *
*  TYPE DECLARATIONS  *
*                     *
**********************/


typedef hash_multimap<unsigned short,RequestPtr> RequestMap;


/***********************
*                      *
*  CLASS REQUESTTABLE  *
*                      *
***********************/


class RequestTable {
public:
  void Add(RequestPtr i_rqp);
  bool IsInTable(RequestPtr i_rqp);

protected:
  RequestMap  m_rm;
  Mutex       m_mutex;
};


/************
*           *
*  THE END  *
*           *
************/


#endif


