

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_RESPONSE_H
#define WWWI_MIND_RESPONSE_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "rrlist.h"


/**********************
*                     *
*  TYPE DECLARATIONS  *
*                     *
**********************/


/*******************
*                  *
*  CLASS RESPONSE  *
*                  *
*******************/


class Response {
public:
			Response(RCode i_cd);
                        Response(bool i_bAA, bool i_bTC, RCode i_cd, RRListPtr &i_rlprAN, RRListPtr &i_rlprNS, RRListPtr &i_rlprAR);
  inline void           AddAN(RRPtr &i_rrp);
  inline bool           GetAA(void) const;
  inline size_t         GetANCount(void) const;
  inline RRListConstPtr GetANList(void) const;
  inline size_t         GetARCount(void) const;
  inline RRListConstPtr GetARList(void) const;
  inline size_t         GetNSCount(void) const;
  inline RRListConstPtr GetNSList(void) const;
  inline RCode          GetRCode(void) const;
  inline bool           GetTC(void) const;
  inline RRListPtr      RemoveANList(void);
  inline RRListPtr      RemoveNSList(void);
  inline void           SetTC(bool i_bTC);
                       ~Response(void);

protected:
  bool          m_bAA;
  bool          m_bTC;
  RCode         m_cd;
  RRListPtr     m_rlpAN;
  RRListPtr     m_rlpNS;
  RRListPtr     m_rlpAR;

};
DECL_POINTER_TYPES(Response)


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


ostream& operator<<(ostream& io_smr, ResponseConstPtr i_rsp);
ostream& operator<<(ostream& io_smr, const Response &i_rsr);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "response.i"

  
/************
*           *
*  THE END  *
*           *
************/


#endif


