

/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "dnsutil.h"


/*******************
*                  *
*  METHODS GETXXX  *
*                  *
*******************/


inline bool Response::GetAA() const { return m_bAA; }
inline size_t Response::GetANCount() const { if (m_rlpAN==NULL) return 0; return m_rlpAN->size(); }
inline RRListConstPtr Response::GetANList() const { return m_rlpAN; }
inline size_t Response::GetARCount() const { if (m_rlpAR==NULL) return 0; return m_rlpAR->size(); }
inline RRListConstPtr Response::GetARList() const { return m_rlpAR; }
inline size_t Response::GetNSCount() const { if (m_rlpNS==NULL) return 0; return m_rlpNS->size(); }
inline RRListConstPtr Response::GetNSList() const { return m_rlpNS; }
inline RCode Response::GetRCode() const { return m_cd; }
inline bool Response::GetTC() const { return m_bTC; }


/**********************
*                     *
*  METHODS REMOVEXXX  *
*                     *
**********************/


inline RRListPtr Response::RemoveANList() { 
  RRListPtr rlpOut = m_rlpAN;
  m_rlpAN = NULL;
  return rlpOut;
}


inline RRListPtr Response::RemoveNSList() {
  RRListPtr rlpOut = m_rlpNS;
  m_rlpNS = NULL;
  return rlpOut;
}


/******************
*                 *
*  METHOD SETXXX  *
*                 *
******************/


inline void Response::SetTC(bool i_bTC) { m_bTC = i_bTC; }


/*****************
*                *
*  METHOD ADDAN  *
*                *
*****************/


void Response::AddAN(RRPtr &i_rrp) {
  if (m_rlpAN==NULL) m_rlpAN = new RRList;
  m_rlpAN->insert(m_rlpAN->begin(),i_rrp);
  i_rrp = NULL;
}


