

/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <cassert>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "dnsutil.h"
#include "rrheader.h"


/********************
*                   *
*  RR CONSTRUCTORS  *
*                   *
********************/


RRHeader::RRHeader() { m_llpName = NULL; }


/******************
*                 *
*  RR DESTRUCTOR  *
*                 *
******************/


RRHeader::~RRHeader() {
  SoftDelete(m_llpName);
}


/*************************
*                        *
*  FUNCTIONS OPERATOR<<  *
*                        *
*************************/


ostream &operator<<(ostream &io_smr, const RRHeader &ci_rrr) {
  io_smr << &ci_rrr;
  return io_smr;      
}


ostream &operator<<(ostream &io_smr, const RRHeader *ci_rrp) {
  io_smr << ci_rrp->GetName() << " " << ci_rrp->GetTTL();   
  return io_smr;
}


ostream &operator<<(ostream &io_smr, const CacheRRHeader &ci_crr) {
  io_smr << &ci_crr;      
  return io_smr;
}


ostream &operator<<(ostream &io_smr, const CacheRRHeader *ci_crp) {
  io_smr << ci_crp->GetTTL();
  return io_smr;
}


