

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_RRHEADER_H
#define WWWI_MIND_RRHEADER_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"
#include "labellist.h"


/**********************
*                     *
*  TYPE DECLARATIONS  *
*                     *
**********************/


/*******************
*                  *
*  CLASS RRHEADER  *
*                  *
*******************/


class RRHeader {
public:
                            RRHeader(void);
  inline LabelListConstPtr  GetName(void) const;
  inline unsigned           GetTTL(void) const;
  inline void               SetTTL(unsigned i_uTTL);
  inline void               SetName(LabelListPtr &i_llpr);
                           ~RRHeader(void);

protected:
  LabelListPtr   m_llpName;
  unsigned       m_uTTL;
};


class CacheRRHeader {
public:
  inline time_t            GetExpire(void) const;
  inline time_t            GetTTL(void) const;
  inline time_t            GetTTL(time_t i_tmNow) const;
  inline bool              IsExpired(time_t i_tmNow) const;
  inline void              SetTTL(unsigned i_uTTL);

protected:
  time_t         m_tmExpire;
};


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


ostream& operator<<(ostream &io_smr, const CacheRRHeader &i_rrr);
ostream& operator<<(ostream &io_smr, const CacheRRHeader *i_rrp);
ostream& operator<<(ostream &io_smr, const RRHeader &i_rrr);
ostream& operator<<(ostream &io_smr, const RRHeader *i_rrp);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "rrheader.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


