

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_RRT_H
#define WWWI_MIND_RRT_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "mind.h"
#include "rdata.h"


/**********************
*                     *
*  TYPE DECLARATIONS  *
*                     *
**********************/


/*************
*            *
*  CLASS RR  *
*            *
*************/


template <class H> class RRT : public H {
public: 
                              RRT(void);
  template <class T> bool     Compare(const T ci_xrp) const;
  inline RRClass              GetClass(void) const;
  inline RDataConstPtr        GetRData(void) const;
  inline RRType               GetType(void) const;
  inline bool                 IsTypeClass(RRType i_ty, RRClass i_cl) const;
  inline void                 SetClass(RRClass i_cl);
  inline void                 SetRData(unsigned char* &i_ucprData, size_t i_szData);
  inline void                 SetRData(RDataPtr &i_rdpr);
  inline void                 SetType(RRType i_ty);
                             ~RRT(void);

  friend class RRFactory;

protected:
  RRType         m_ty;
  RRClass        m_cl;
  RDataPtr       m_rdp;

};


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


template <class H> ostream& operator<<(ostream &io_smr, const RRT<H> &i_rrr);
template <class H> ostream& operator<<(ostream &io_smr, const RRT<H> *i_rrp);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "rrt.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


