

/*************
*            *
*  SENTINEL  *
*            *
*************/


#ifndef WWWI_MIND_RRTLIST_H
#define WWWI_MIND_RRTLIST_H


/**********************
*                     *
*  COMPILER INCLUDES  *
*                     *
**********************/


#include <list>


/*********************
*                    *
*  PROJECT INCLUDES  *
*                    *
*********************/


#include "question.h"
#include "rrt.h"


using std::list;


/*****************
*                *
*  CLASS RRLIST  *
*                *
*****************/


template <class H> class RRTList : public list< H > {
public:
  unsigned                       Expire(time_t i_tmNow, time_t &io_tmrNextExpire);
  typename RRTList<H>::iterator  GetRandomRR(void);
  template <class XRP> bool      HasResourceMatch(const XRP ci_xrp) const;
  bool                           HasTypeClass(RRType i_ty, RRClass i_cl) const;
  bool                           HasQuestionMatch(QuestionConstPtr ci_qnp) const;
  void                           Walk(ostream &io_smr, int i_iDepth) const;
                                ~RRTList(void);

};


/************************
*                       *
*  FUNCTION PROTOTYPES  *
*                       *
************************/


template <class T> ostream& operator<<(ostream& io_smr, const RRTList<T> &i_xrr);
template <class T> ostream& operator<<(ostream& io_smr, const RRTList<T> *i_xrp);


/*********************
*                    *
*  INLINE FUNCTIONS  *
*                    *
*********************/


#include "rrtlist.i"


/************
*           *
*  THE END  *
*           *
************/


#endif


