

#include "tests.h"
#include "../rrcache.h"


MODULE(BufferTest)
  Buffer bf(512);

  unsigned char uc = 191;
  unsigned char uc2 = 0;
  bf.SetPos(12);
  bf.Write(uc);
  TEST("Write uc",bf.GetPos(),13);
  bf.SetPos(12);
  bf.Read(uc2);
  TEST("Read uc",bf.GetPos(),13);
  TEST("Buffer uc",uc,uc2);

  unsigned short us = 0x1375;
  unsigned short us2 = 0;
  bf.SetPos(19);
  bf.Write(us);
  TEST("Write us",bf.GetPos(),21);
  bf.SetPos(19);
  bf.Read(us2);
  TEST("Read us",bf.GetPos(),21);
  TEST("Buffer us",us,us2);

  bf.SetPos(19);
  bf.WriteNBO(us);
  TEST("WriteNBO us",bf.GetPos(),21);
  bf.SetPos(19);
  bf.ReadNBO(us2);
  TEST("ReadNBO us",bf.GetPos(),21);
  TEST("Buffer us",us,us2);

  unsigned long ul = 0x91A4C0D7;
  unsigned long ul2 = 0;
  bf.SetPos(508);
  bf.Write(ul);
  TEST("Write ul",bf.GetPos(),512);
  bf.SetPos(508);
  bf.Read(ul2);
  TEST("Read ul",bf.GetPos(),512);
  TEST("Buffer ul",ul,ul2);

  bf.SetPos(0);
  bf.WriteNBO(ul);
  TEST("WriteNBO ul",bf.GetPos(),4);
  bf.SetPos(0);
  bf.ReadNBO(ul2);
  TEST("ReadNBO ul",bf.GetPos(),4);
  TEST("Buffer ul",ul,ul2);

  char     str[30] = "DNS Tests are very important.";
  char     str2[30] = "This is the wrong string.";
  bf.SetPos(52);
  bf.WriteData(str,30);
  TEST("WriteData",bf.GetPos(),82);
  bf.SetPos(52);
  bf.ReadData(str2,30);
  TEST("ReadData",bf.GetPos(),82);
  TEST("Buffer raw",strcmp(str,str2),0);

ENDMODULE


