

#include <exception>


#include "../am.h"
#include "../mind.h"
#include "../labellist.h"
#include "../mindlog.h"
#include "../request.h"
#include "../rr.h"
#include "tests.h"
#include "wwwi/exception.h"
#include "wwwi/singleton.h"


using WWWI::Exception;
using WWWI::GetSingleton;


int main() {
  int tests = 0;
  int passes = 0;

  try {
    GetSingleton<MINDLog>()->WouldLog(LF_MISC,LY_DEBUG);
    GetSingleton<AM<LabelList> >();
    GetSingleton<AM<RR> >();
    GetSingleton<AM<CacheRR> >();
    GetSingleton<AM<Label> >();
    GetSingleton<AM<Request> >();
    GetSingleton<RefMgr<LabelList> >();
    GetSingleton<RefMgr<RR> >();

    cout << "Beginning tests." << endl;

//    RUN_MODULE(BufferTest);
//    RUN_MODULE(CacheTest);
//    RUN_MODULE(DNSPacketTest);
//    RUN_MODULE(LLTest);
//    RUN_MODULE(LogTest);

    cout << endl << "Total number of tests: " << tests << endl;
    cout << "Total tests passed: " << passes << endl;

    if (passes!=tests) {
      cout << "WARNING! Not all tests were passed!" << endl;
    }
  } catch (exception &exr) {
    cout << "EXCEPTION: " << exr.what() << endl;
  } catch (Exception &exr) {
    cout << "LIB EXCEPTION: " << exr.m_strMessage << endl;
  }

}

