

#ifndef WWWI_MIND_WATCHPTR_H
#define WWWI_MIND_WATCHPTR_H

/*
 *  The WatchPtr class is used to allow a pointer to obtain automatic 
 *  destruction when the current stack frame exits.  This is primarily useful
 *  to clean up when exceptions occur and memory has been allocated with new.
 */

template <class T> class WatchPtr {
public:
  WatchPtr(T &i_t) { m_tp = &i_t; m_bProtect=true; }
  void  Release(void) { m_bProtect = false; }
  ~WatchPtr(void) { if (m_bProtect==false) return; SoftDelete(*m_tp); }
protected:
  T *m_tp;
  bool m_bProtect;
};


#endif


